function y = Cheby1Poly(x, M)
% Evaluate an M'th order Chebyshev polynomial of the first kind
% y = Cheby1Poly(x, M)
% y <-  Value of the polynomial at the points specified by x
% x  -> Vector of x values
% M  -> Polynomial order

% $Id: Cheby1Poly.m,v 1.2 2025/01/29 16:29:15 pkabal Exp $

Nx = length(x);
y = NaN(size(x));
for k = 1:Nx
  xk = x(k);
  if (xk >= -1 && xk <= +1)
    y(k) = cos(M * acos(xk));
  elseif (x(k) > 1)
    y(k) = cosh(M * acosh(xk));
  else
    y(k) = (-1)^M *cosh(M * acosh(-xk));
  end
end

end
